package com.radxa.com.radxa_gpio;

import android.util.Log;

import java.io.File;

/**
 * Created by Administrator on 2015/11/28.
 */
public class GpioUtil {
    final String TAG = "GpioUtil";
    public final int[] extender_header_gpios = {167};//,169,188,189,190,191,192,193,194,196,197,198,199,202,203,204,205,207,216,217,284,285,286};

    static {
        // The runtime will add "lib" on the front and ".o" on the end of
        // the name supplied to loadLibrary.
        System.loadLibrary("gpioutil");
    }

    public boolean isOccupiedByOther = false;
    public boolean isRequested = false;

    public int setVal(int pin, int val) {
        Log.i(TAG, "gpioctl xx setVal pin " + pin  + " value = " + val);

        if (false == isRequested) {
            int ret = requestGpio(pin);
            isRequested = true;
            if(ret < 0){
                Log.e(TAG,"gpio is occupied by other");
                isOccupiedByOther = true;
                return -1;
            }
        }

        return setVal_native(pin, val);
    }

    public int getVal(int pin) {
        int value = getVal_native(pin);
        Log.i(TAG, "gpioctl getval value = " + value);
        return value;
    }

    public int openDev(String path){
        File device = new File(path);
        if (!device.canRead() || !device.canWrite()) {
            try {
                Process su;
                su = Runtime.getRuntime().exec("/system/xbin/su");
                String cmd = "chmod 777 " + device.getAbsolutePath() + "\n"
                        + "exit\n";

                su.getOutputStream().write(cmd.getBytes());
                if ((su.waitFor() != 0) || !device.canRead()
                        || !device.canWrite()) {
                    throw new SecurityException();
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new SecurityException();
            }
        }
        Log.i(TAG, "gpioctl openDev_native");
        return openDev_native(path);
    }

    public int closeDev(){
        Log.d(TAG, "closeDev");
        return closeDev_native();
    }

    public int releaseGpio(int pin){
        Log.d(TAG, "closeDev");
        return releaseGpio_native(pin);
    }

    public int requestGpio(int pin){
        Log.d(TAG, "requestGpio");
        return requestGpio_native(pin);
    }

    private static native int setVal_native(int pin, int val);
    private static native int getVal_native(int pin);
    private static native int openDev_native(String path);
    private static native int closeDev_native();
    private static native int releaseGpio_native(int pin);
    private static native int requestGpio_native(int pin);
}
